#include <stdio.h>
#include <stdlib.h>

#include "PlayerOnePW.h"

int main()
{
    int PW_count = POAGetPWCount();

    printf("PW count: %d\n", PW_count);
    if(PW_count <= 0)
    {
        printf("there is no Player One filter wheel! \n");

        getchar();

        return 0;
    }

    //malloc pointer memory first
    PWProperties **ppPOA_PW_Prop = (PWProperties **)malloc(sizeof(PWProperties *) * PW_count);

    int i;
    for(i = 0; i < PW_count; i++)
    {
        ppPOA_PW_Prop[i] = (PWProperties *)malloc(sizeof (PWProperties)); //malloc the PWProperties memory

        PWErrors error = POAGetPWProperties(i, ppPOA_PW_Prop[i]);

        if(error == PW_OK)
        {
            //print PW Handle and Name
            printf("PW Handle: %d, PW name: %s \n", ppPOA_PW_Prop[i]->Handle, ppPOA_PW_Prop[i]->Name);
            //print PW SN and PW position count
            printf("PW SN: %s \n PW Position Count: %d \n", ppPOA_PW_Prop[i]->SN, ppPOA_PW_Prop[i]->PositionCount);
        }
        else
        {
            free(ppPOA_PW_Prop[i]);
            ppPOA_PW_Prop[i] = NULL;
            printf("get PW properties failed, index: %d, error code: %s \n", i, POAGetPWErrorString(error));
        }
    }

    //operate the first PW

    int handle, position_count, goto_position;

    handle = ppPOA_PW_Prop[0]->Handle;

    position_count = ppPOA_PW_Prop[0]->PositionCount;

    // open PW
    PWErrors error;
    error = POAOpenPW(handle);

    if(error != PW_OK)
    {
        printf("Open PW Failed, error code: %s \n", POAGetPWErrorString(error));

        //free the memory
        for(i = 0; i < PW_count; i++)
        {
            if(ppPOA_PW_Prop[i])
            {
                free(ppPOA_PW_Prop[i]);
                ppPOA_PW_Prop[i] = NULL;
            }
        }

        free(ppPOA_PW_Prop);
        ppPOA_PW_Prop = NULL;

        return 0;
    }

    //NOTE: When opened successfully, phoenix filter wheel will goto 1st position,menas: index == 0;

    //Detect PW is moving
    //You can ignore this step in your APP, in this demo, just waiting for PW stop moving
    PWState pw_state = PW_STATE_OPENED;
    do
    {
        POAGetPWState(handle, &pw_state);
    }while(pw_state == PW_STATE_MOVING);

    //get the current position
    goto_position = 0;
    error = POAGetCurrentPosition(handle, &goto_position);
    printf("get PW current position, pos: %d, error code: %s \n \n", goto_position, POAGetPWErrorString(error));

    printf("Goto Poistion Testing: \n");

    do
    {
        printf("--> Please input a number in the range[0 - %d], if the number < 0, this Goto Poistion Testing will quit: \n", position_count-1);
        scanf("%d", &goto_position);

        if(goto_position < 0)
        {
            printf("goto poistion testing quit.... \n");
            break;
        }

        if(goto_position >= position_count)
        {
            printf("The number you inputed is out of range.... \n");
            continue;
        }

        error = POAGotoPosition(handle, goto_position); // goto position

        printf("got position: %d, error string: %s \n", goto_position, POAGetPWErrorString(error));

        if(error == PW_OK) //waiting for PW stop moving
        {
            PWState pw_state = PW_STATE_OPENED;

            do
            {
                POAGetPWState(handle, &pw_state);
            }while(pw_state == PW_STATE_MOVING);
        }

    }while(1);


    //Close PW
    POAClosePW(handle);


    //free the memory
    for(i = 0; i < PW_count; i++)
    {
        if(ppPOA_PW_Prop[i])
        {
            free(ppPOA_PW_Prop[i]);
            ppPOA_PW_Prop[i] = NULL;
        }
    }

    free(ppPOA_PW_Prop);
    ppPOA_PW_Prop = NULL;

    return 0;
}
